-- bot config --
bot_to_player_ratio = 2 -- how many bots spawn for each alive player
norm_bot_max_hits = 10 -- amount of glock hits to kill the strongest bot (without armor)
special_bot_max_hits = 4 -- amount of glock hits to kill the strongest special bot (without armor)
event_bot_health = 5 -- amount of glock hits to kill the event bots
max_bot_spd = 15 -- the maximum random speed level of non-event bots
special_bot_spawn_chance = 20 -- percentage chance that a special bot is spawned (1-100)
rare_bot_equip = {51,52,72,73,76,85} -- special bot spawn equip ids

-- player config --
rare_reward_gun_chance = 3 -- % chance a player will get a rare gun on first kill (reduces by math per kill)
reward_gun_chance = 10 -- % chance a player will get a gun on first kill (reduces by math per kill)
speed_boost = 20 -- the power level of player speed boost (1-100)
gun_table = {1,2,3,4,5,6,10,11,10,22,24,30,31,32,33,34,35,36,37,38,39,91} -- gun ids for player rewards
rare_gun_table = {40,45,46,47,48,49,90} -- rare gun ids for player rewards

-- map config
map_item_spawns = {75,75,61,62,65} -- id of stuff that spawns around the map
map_item_spawn_chance = 12 -- percentage chance that an item will spawn on the map after bot kill (1,100)
tile_spawn = 0 -- bots spawn on this tile #
tile_bonus = 1 -- map items spawn on this tile #
tile_gates = 1  -- gates spawn on this tile #

-- math for the above, do not alter --
norm_bot_max_hits = norm_bot_max_hits*2
special_bot_max_hits = special_bot_max_hits*2
special_bot_spawn_chance = math.floor((1/special_bot_spawn_chance)*100)
map_item_spawn_chance = math.floor((1/map_item_spawn_chance)*100)