addhook("serveraction","musicOnOff")
addhook("leave","musicReset")
addhook("spawn","musicHud")
musicBpm = {}
lengthLoop = {}
wantMusic = {}
waiting = {}

-- list the bpms of your music --
musicBpm[1] = 100 -- add 1 to the square bracketed number to add another bpm
musicBpm[2] = 110
musicBpm[3] = 120

for id = 1,32 do
wantMusic[id] = false
waiting[id] = false
end

for bpmToMs = 1,table.maxn(musicBpm) do
musicBpm[bpmToMs] = 240000/musicBpm[bpmToMs] -- works out the length of a bar in ms at each bpm you added
end

function musicReset(id)
wantMusic[id] = false
waiting[id] = false
end

function musicHud(id)
	if wantMusic[id] == false then
	parse('hudtxt2 '..id..' 0 "©000255255Press F4 to turn music on!" 640 462 1 0 12')
	parse('hudtxtalphafade '..id..' 0 500 0.7')
	elseif wantMusic[id] == true then
	parse('hudtxt2 '..id..' 0 "©000255255Press F4 to turn music off!" 640 462 1 0 12')
	parse('hudtxtalphafade '..id..' 0 500 0.7')
	end
end

function musicOnOff(id,action)
	if (action == 3) and wantMusic[id] == false and waiting[id] == false then -- press f4 to turn music on and off
	wantMusic[id] = true
	parse('hudtxt2 '..id..' 0 "©000255255Press F4 to turn music off!" 640 462 1 0 12')
	parse('hudtxtalphafade '..id..' 0 500 0.7')
	musicOnScore(id)
	print(""..player(id,"name").." "..player(id,"score").." music on")
	elseif (action == 3) and wantMusic[id] == true then
	wantMusic[id] = false
	waiting[id] = true
	parse('hudtxt2 '..id..' 0 "©000255255Turning off music..." 640 462 1 0 12')
	parse('hudtxtalphafade '..id..' 0 500 0.7')
	print(""..player(id,"name").." "..player(id,"score").." music off")
	end
end

function musicOnScore(id)
id = tonumber(id)
	if wantMusic[id] == true then
		if player(id,"score")<=50 then -- if the players score is lower or equal to 125 then play music, change the number to what you want
		parse("sv_sound2 "..id.." /machette_madness_sounds/mm_music_level_one.ogg") -- change the file location to your first piece of music in the cs2d sfx folder
		timer(musicBpm[1]*8, "musicOnScore", id) -- change musicBpm's square bracketed number to one on the list you made and match the bpm of your file and multiply it by the length of your file in bars
		elseif player(id,"score")>50 and player(id,"score")<= 100 then -- add more by copying and pasting these three lines of code
		parse("sv_sound2 "..id.." /machette_madness_sounds/mm_music_level_two.ogg")
		timer(musicBpm[2]*4, "musicOnScore", id)
		elseif player(id,"score")>100 then -- keep a score ceiling to prevent players exceeding your score ranges and the music system bugging out
		parse("sv_sound2 "..id.." /machette_madness_sounds/mm_music_level_three.ogg")
		timer(musicBpm[3]*8, "musicOnScore", id)
		end
	elseif wantMusic[id] == false then
	parse('hudtxt2 '..id..' 0 "©000255255Press F4 to turn music on!" 640 462 1 0 12')
	parse('hudtxtalphafade '..id..' 0 500 0.7')
	waiting[id] = false
	end
end