addhook("spawn","reset_scores")
addhook("spawn","hide_highscores")
addhook("kill","multiplier_and_glow_update")
addhook("hit","special_attack")
addhook("die","game_over")
addhook("die","show_hs")
addhook("leave","update_high_scores")
addhook("movetile","move_add_score")
in_game_player_score = {}
high_score_table = {}
score_multiplier = {}
glow_by_score_amount = {}
special_hit_score_bonus = {}
display_hit_bonus = {}
move_bonus = {}

-- loading, saving and calculating scores --
number = 1

check_high_score_exists = io.open("sys/lua/highscore/highscore.txt","r")
if check_high_score_exists ~= nil then 
io.close(check_high_score_exists)
else
high_score_table[1] = "no highscore set"
high_score_table[2] = 0
high_score_table[3] = "no highscore set"
high_score_table[4] = 0
high_score_table[5] = "no highscore set"
high_score_table[6] = 0
high_score_table[7] = "no highscore set"
high_score_table[8] = 0
high_score_table[9] = "no highscore set"
high_score_table[10] = 0
high_score_table[11] = "no highscore set"
high_score_table[12] = 0
high_score_table[13] = "no highscore set"
high_score_table[14] = 0
high_score_table[15] = "no highscore set"
high_score_table[16] = 0
high_score_table[17] = "no highscore set"
high_score_table[18] = 0
high_score_table[19] = "no highscore set"
high_score_table[20] = 0
high_score_save = io.open("sys/lua/highscore/highscore.txt", "w")
	for quick_key = 1,20 do
	high_score_save:write(""..high_score_table[quick_key].."\n")
	end
high_score_save:close()
end

for line in io.lines("sys/lua/highscore/highscore.txt") do  -- for each line that exists it loops loading each line into the high score table
	if (number % 2 == 0) then
	table.insert (high_score_table, tonumber(line));
	else
	table.insert (high_score_table, line);
	end
number = number + 1
end

function show_hs(id)
parse('hudtxt2 '..id..' 9 "©255000000Highscores" 690 130 1 0 30')
parse('hudtxt2 '..id..' 10 "©255000000Rank" 580 175 1 0 16')
parse('hudtxt2 '..id..' 11 "©255000000Name" 690 175 1 0 16')
parse('hudtxt2 '..id..' 12 "©255000000Score" 800 175 1 0 16')
parse('hudtxt2 '..id..' 13 "©255000000#1" 580 196 1 0 12')
parse('hudtxt2 '..id..' 14 "©255000000#2" 580 210 1 0 12')
parse('hudtxt2 '..id..' 15 "©255000000#3" 580 224 1 0 12')
parse('hudtxt2 '..id..' 16 "©255000000#4" 580 238 1 0 12')
parse('hudtxt2 '..id..' 17 "©255000000#5" 580 252 1 0 12')
parse('hudtxt2 '..id..' 18 "©255000000#6" 580 266 1 0 12')
parse('hudtxt2 '..id..' 19 "©255000000#7" 580 280 1 0 12')
parse('hudtxt2 '..id..' 20 "©255000000#8" 580 294 1 0 12')
parse('hudtxt2 '..id..' 21 "©255000000#9" 580 308 1 0 12')
parse('hudtxt2 '..id..' 22 "©255000000#10" 580 322 1 0 12')
parse('hudtxt2 '..id..' 23 "©255000000'..high_score_table[1]..'" 690 196 1 0 12')
parse('hudtxt2 '..id..' 24 "©255000000'..high_score_table[3]..'" 690 210 1 0 12')
parse('hudtxt2 '..id..' 25 "©255000000'..high_score_table[5]..'" 690 224 1 0 12')
parse('hudtxt2 '..id..' 26 "©255000000'..high_score_table[7]..'" 690 238 1 0 12')
parse('hudtxt2 '..id..' 27 "©255000000'..high_score_table[9]..'" 690 252 1 0 12')
parse('hudtxt2 '..id..' 28 "©255000000'..high_score_table[11]..'" 690 266 1 0 12')
parse('hudtxt2 '..id..' 29 "©255000000'..high_score_table[13]..'" 690 280 1 0 12')
parse('hudtxt2 '..id..' 30 "©255000000'..high_score_table[15]..'" 690 294 1 0 12')
parse('hudtxt2 '..id..' 31 "©255000000'..high_score_table[17]..'" 690 308 1 0 12')
parse('hudtxt2 '..id..' 32 "©255000000'..high_score_table[19]..'" 690 322 1 0 12')
parse('hudtxt2 '..id..' 33 "©255000000'..high_score_table[2]..'" 800 196 1 0 12')
parse('hudtxt2 '..id..' 34 "©255000000'..high_score_table[4]..'" 800 210 1 0 12')
parse('hudtxt2 '..id..' 35 "©255000000'..high_score_table[6]..'" 800 224 1 0 12')
parse('hudtxt2 '..id..' 36 "©255000000'..high_score_table[8]..'" 800 238 1 0 12')
parse('hudtxt2 '..id..' 37 "©255000000'..high_score_table[10]..'" 800 252 1 0 12')
parse('hudtxt2 '..id..' 38 "©255000000'..high_score_table[12]..'" 800 266 1 0 12')
parse('hudtxt2 '..id..' 39 "©255000000'..high_score_table[14]..'" 800 280 1 0 12')
parse('hudtxt2 '..id..' 40 "©255000000'..high_score_table[16]..'" 800 294 1 0 12')
parse('hudtxt2 '..id..' 41 "©255000000'..high_score_table[18]..'" 800 308 1 0 12')
parse('hudtxt2 '..id..' 42 "©255000000'..high_score_table[20]..'" 800 322 1 0 12')
end

function hide_highscores(id)
	for high_clear = 9,42 do
	parse('hudtxt2 '..id..' '..high_clear..' " " 0 0')
	end
end

function update_scores(id)
in_game_player_score[id]=(player(id,"score")*120)+(((player(id,"score")*2)*score_multiplier[id])+special_hit_score_bonus[id]+move_bonus[id]) -- math to calculate each id's score
parse('hudtxt2 '..id..' 7 "©000255000Score: '..in_game_player_score[id]..'" 425 15 1 0 18')
parse('hudtxtalphafade '..id..' 7 500 0.7')
end

function update_high_scores(id)
	if player(id,"bot") == false and player(id,"name") ~= "SomeRandomRustGuy" then
		if in_game_player_score[id] > high_score_table[2] then -- if they beat the high score
		high_score_table[1] = player(id,"name") -- change table details to theirs
		high_score_table[2] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[4] then -- if not check if they beat the highscore below that
		high_score_table[3] = player(id,"name") -- change table details to theirs
		high_score_table[4] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[6] then -- etc
		high_score_table[5] = player(id,"name")
		high_score_table[6] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[8] then
		high_score_table[7] = player(id,"name")
		high_score_table[8] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[10] then
		high_score_table[9] = player(id,"name")
		high_score_table[10] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[12] then
		high_score_table[11] = player(id,"name")
		high_score_table[12] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[14] then
		high_score_table[13] = player(id,"name")
		high_score_table[14] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[16] then
		high_score_table[15] = player(id,"name")
		high_score_table[16] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[18] then
		high_score_table[17] = player(id,"name")
		high_score_table[18] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		elseif in_game_player_score[id] > high_score_table[20] then
		high_score_table[19] = player(id,"name")
		high_score_table[20] = in_game_player_score[id]
		high_score_update = 1
		parse('sv_msg "NEW HIGHSCORE@C"')
		end
		if high_score_update == 1 then
		high_score_update = 0
		high_score_save = io.open("sys/lua/highscore/highscore.txt", "w") -- save the whole table
			for quick_key = 1,20 do
			high_score_save:write(""..high_score_table[quick_key].."\n")
			end
		high_score_save:close()
		end
	end
parse("setscore "..id.." 0")
end

-- resetting, adding and effects for scores --
function reset_scores(id)
	if player(id,"bot") == false then
	glow_by_score_amount[id] = image("gfx/sprites/flare.png",1,0,200+id) -- creating image on spawn
	imageblend(glow_by_score_amount[id],1)								
	imagealpha(glow_by_score_amount[id],0.5)
	imagecolor(glow_by_score_amount[id],0,0,0) -- glow color reset
	score_multiplier[id] = 1
	special_hit_score_bonus[id] = 0
	move_bonus[id] = 0
	parse('hudtxt2 '..id..' 8 "©000255000Score multiplier: '..score_multiplier[id]..'" 425 0 1')
	parse('hudtxtalphafade '..id..' 8 500 0.7')
	update_scores(id)
	end
end

function multiplier_and_glow_update(killer,victim,weapon)
	if player(killer,"bot") == false then
	score_multiplier[killer] = score_multiplier[killer] + 1	-- score multiplier increase for killer on each bot kill
	parse('hudtxt2 '..killer..' 8 "©000255000Score multiplier: '..score_multiplier[killer]..'" 425 0 1') -- update score multiplier hud
	parse('hudtxtalphafade '..killer..' 8 500 0.7')
	in_game_player_score[killer] = in_game_player_score[killer] + math.random(1,score_multiplier[killer])
	update_scores(killer)
		if player(killer,"score") <= 255 then 
		imagecolor(glow_by_score_amount[killer],(player(killer,"score")),0,0)				
		elseif player(killer,"score") > 255 and player(killer,"score") <= 510 then
		imagecolor(glow_by_score_amount[killer],255,(player(killer,"score"))-255,(player(killer,"score"))-255)						
		elseif player(killer,"score") > 510 then	
		imagecolor(glow_by_score_amount[killer],255,255,255)
		end
	elseif player(victim,"bot") == false then
	imagecolor(glow_by_score_amount[victim],0,0,0)
	end
end

function special_attack(victim,attacker,weapon)
    if (weapon == 75) and player(victim,"bot") == true then -- if snowball hits a bot
	special_hit_score_bonus[attacker] = special_hit_score_bonus[attacker] + score_multiplier[attacker] * 8 -- calculate the score for attacker
	display_hit_bonus[attacker] = score_multiplier[attacker] * 8
	parse('sv_msg2 '..attacker..' "+'..display_hit_bonus[attacker]..' snowball hit bonus score"') -- shows the attacker how much score they got from that special attack
	update_scores(attacker)
	elseif (weapon == 50) and player(victim,"bot") == true then -- if knife bot
	special_hit_score_bonus[attacker] = special_hit_score_bonus[attacker] + score_multiplier[attacker] * 2 -- calculate the score for attacker
	display_hit_bonus[attacker] = score_multiplier[attacker] * 2
	parse('sv_msg2 '..attacker..' "+'..display_hit_bonus[attacker]..' knife hit bonus score"') -- shows the attacker how much score they got from that special attack
	update_scores(attacker)
	elseif player(victim,"bot") == false then
	freeimage(200+victim) -- deleting old image on death
	end
end

function game_over(victim)
	if player(victim,"bot") == false and player(victim,"team") == 1 then
	parse('sv_msg2 '..victim..' "GAME OVER@C"')
	parse('sv_msg2 '..victim..' "Your score: '..in_game_player_score[victim]..'@C"') -- shows victims final score at the center of the screen
	parse('hudtxt2 '..victim..' 7 " " 300 18 0') -- clear huds
	parse('hudtxt2 '..victim..' 8 " " 300 18 0')
	update_high_scores(victim)
	show_hs(victim)
		for spec_up = 1,32 do
			if player(spec_up,"team") == 0 and player(spec_up,"bot") == false then
			show_hs(spec_up)
			end
		end
	end
end

function move_add_score(id)
	if move_bonus[id] == nil then
	move_bonus[id] = 0
	end
	if player(id,"bot") == false then
	banana = math.random(0,5)
		if banana == 1 then
		move_bonus[id] = move_bonus[id]+banana
		update_scores(id)
		end
	end
end